package com.chelvc.cloud.vehicle.server.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.chelvc.cloud.vehicle.client.param.MerchantApplyRecordParam;
import com.chelvc.cloud.vehicle.server.dao.MerchantApplyRecordMapper;
import com.chelvc.cloud.vehicle.server.entity.MerchantApplyRecord;
import com.chelvc.cloud.vehicle.server.service.MerchantApplyRecordService;
import com.chelvc.cloud.vehicle.server.service.MerchantRelationService;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;

@Service
@RequiredArgsConstructor(onConstructor = @__(@Autowired))
public class MerchantApplyRecordServiceImpl extends
        ServiceImpl<MerchantApplyRecordMapper, MerchantApplyRecord> implements MerchantApplyRecordService {

    private final MerchantRelationService merchantRelationService;

    @Override
    public int insert(MerchantApplyRecord record) {
        return baseMapper.insert(record);
    }

    @Override
    public void updateByNotify(MerchantApplyRecordParam param) {
        String requestId = param.getRequestId();
        LambdaQueryWrapper<MerchantApplyRecord> wrapper = Wrappers.lambdaQuery();
        wrapper.eq(MerchantApplyRecord::getRequestId, requestId);
        MerchantApplyRecord record = baseMapper.selectOne(wrapper);
        record.setExamineStatus(param.getSubMerchantReviewStatus());
        record.setCertificateSupplementUrl(param.getCertificateSupplementUrl());
        record.setElectronicContractingUrl(param.getElectronicContractingUrl());
        record.setMerchantReviewRemarks(param.getSubMerchantReviewRemarks());
        record.setPostReviewRemark(param.getPostReviewRemark());
        record.setPostReviewStatus(param.getPostReviewStatus());
        record.setSubMerchantId(param.getSubMerchantId());
        record.setUpdateTime(new Date());
        baseMapper.updateById(record);
        merchantRelationService.insert(record.getUserId(), record.getType(), param.getSubMerchantId());
    }
}
